import { getCurrentInstance, inject } from 'vue-demi';
import { debug } from '../env';
/**
 * activeFetch must be called to handle SSR at the top of functions like
 * `fetch`, `setup`, `serverPrefetch` and others
 */
export var activeFetch;
/**
 * inject key
 */
export var fetchSymbol = debug ? Symbol.for('__VUE_ASYNC_Fetch__') : Symbol();
/**
 * Set or unset active fetch, Used in SSR and internally when calling
 * actions and getters
 * @param fetch Fetch instance
 */
export var setActiveFetch = function (fetch) { return (activeFetch = fetch); };
/**
 * Get the currently active fetch if there is any.
 */
export var getActiveFetch = function () { return (getCurrentInstance() && inject(fetchSymbol)) || activeFetch; };
//# sourceMappingURL=rootFetch.js.map